<template>
  <div>
    <el-upload :action="`${path}/cms/mediaFile/upload?category=${props.category}`" :show-file-list="false"
      :multiple="false" :before-upload="beforeUpload" :on-error="uploadFailure" :on-success="uploadSuccess">
      <el-button type="primary" plain icon="picture">{{ props.label }}</el-button>
    </el-upload>
  </div>
</template>

<script setup>
import { ref } from 'vue'
import { ElMessage } from 'element-plus'
import ImageCompress from '@/utils/image'

defineOptions({
  name: 'UploadImage',
})

const emit = defineEmits([
  'on-before-upload',
  'on-failure',
  'on-success',
])
const props = defineProps({
  category: {
    type: String, required: true
  },
  imageUrl: {
    type: String,
    default: ''
  },
  fileSize: {
    type: Number,
    default: 2048 // 2M 超出后执行压缩
  },
  maxWH: {
    type: Number,
    default: 1920 // 图片长宽上限
  },
  label: {
    type: String, default: '压缩上传'
  }
})

const path = ref(import.meta.env.VITE_BASE_API)

const beforeUpload = (file) => {
  const isJPG = file.type === 'image/jpeg'
  const isPng = file.type === 'image/png'
  if (!isJPG && !isPng) {
    ElMessage.error('上传图片只能是 jpg或png 格式!')
    return false
  }

  emit('on-before-upload')

  const isRightSize = file.size / 1024 < props.fileSize
  if (!isRightSize) {
    // 压缩
    const compress = new ImageCompress(file, props.fileSize, props.maxWH)
    return compress.compress()
  }

  return isRightSize
}

const uploadFailure = () => {
  console.log('on-failure')
  ElMessage({
    type: 'error',
    message: '上传失败'
  })
  emit('on-failure')
}

const uploadSuccess = (res) => {
  console.log('on-success')
  const { code, data, msg } = res
  if (code !== 0) {
    ElMessage({ type: 'error', message: msg })
    emit('on-failure')
  }
  if (!data.mediaFile) {
    ElMessage({ type: 'error', message: '返回错误，上传失败' })
    emit('on-failure')
  }
  emit('on-success', data.mediaFile)
}

</script>

<style lang="scss" scoped>
.image-uploader {
  border: 1px dashed #d9d9d9;
  width: 180px;
  border-radius: 6px;
  cursor: pointer;
  position: relative;
  overflow: hidden;
}

.image-uploader {
  border-color: #409eff;
}

.image-uploader-icon {
  font-size: 28px;
  color: #8c939d;
  width: 178px;
  height: 178px;
  line-height: 178px;
  text-align: center;
}

.image {
  width: 178px;
  height: 178px;
  display: block;
}
</style>
